<template>
  <v-app>
    <img class="background" :src="require('./assets/bg.jpg')"/>
    <div v-for="n in 100" :key="n" class="circle-container">
      <div class="circle"></div>
    </div>
    <v-main class="container">
      <router-view/>
    </v-main>
    <v-footer class="font-weight-medium low-opacity">
      <v-col class="text-center" cols="12">
        <div class="d-flex justify-center">
          <div>Made with ❤️ by <strong>MaDetho</strong></div>
          <v-btn class="mx-4" x-small icon color="blue" href="https://twitter.com/MaDetho" target="_blank">
            <v-icon>mdi-twitter</v-icon>
          </v-btn>
          <v-btn x-small icon href="mailto:madetho@live.de">
            <v-icon>mdi-email</v-icon>
          </v-btn>
        </div>
      </v-col>
    </v-footer>
  </v-app>
</template>

<script>
import { useActions } from '@u3u/vue-hooks';

export default {
  name: 'App',
  setup() {
    const { reAuth } = useActions('auth', [
      'reAuth',
    ]);
    reAuth();
  },
};
</script>
<style lang="scss">
.player-font {
  font-family: 'Bebas Neue', cursive;
  font-size: 34px;
}

.low-opacity {
  background: rgb(0, 0, 0, 0.5);
}

.no-opacity {
  background: rgb(0, 0, 0, 0.0);
}

* {
  margin: 0;
  padding: 0;
}

html,
body {
  width: 100%;
  height: 100%;
  overflow: hidden;
}

body {
  background-color: #021027;
}

.scroll::-webkit-scrollbar-track {
  -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,0.3);
  background-color: #191919;
}

.scroll::-webkit-scrollbar {
  width: 6px;
  background-color: #F5F5F5;
}

.scroll::-webkit-scrollbar-thumb {
  background-color: #909090;
}

.container {
  width: 100%;
  height: 100%;
  overflow: hidden;
  position: relative;
  flex: unset !important;
}

.background {
  display: block;
  position: absolute;
  top: 0;
  left: 0;
  object-fit: cover;
  width: 100%;
  height: 100%;

  mask-image: radial-gradient(
    white 0%,
    white 30%,
    transparent 80%,
    transparent
  );
}

.circle-container {
  $particleNum: 200;
  $particleColor: hsl(180, 100%, 80%);

  position: absolute;
  transform: translateY(-10vh);
  animation-iteration-count: infinite;
  animation-timing-function: linear;

  .circle {
    width: 100%;
    height: 100%;
    border-radius: 50%;
    mix-blend-mode: screen;
    background-image: radial-gradient(
      hsl(180, 100%, 80%),
      hsl(180, 100%, 80%) 10%,
      hsla(180, 100%, 80%, 0) 56%
    );

    animation: fadein-frames 200ms infinite, scale-frames 2s infinite;

    @keyframes fade-frames {
      0% {
        opacity: 1;
      }

      50% {
        opacity: 0.7;
      }

      100% {
        opacity: 1;
      }
    }

    @keyframes scale-frames {
      0% {
        transform: scale3d(0.4, 0.4, 1);
      }

      50% {
        transform: scale3d(2.2, 2.2, 1);
      }

      100% {
        transform: scale3d(0.4, 0.4, 1);
      }
    }
  }

  $particleBaseSize: 8;
  @for $i from 1 through $particleNum {
    &:nth-child(#{$i}) {
      $circleSize: random($particleBaseSize);
      width: $circleSize + px;
      height: $circleSize + px;

      $startPositionY: random(10) + 100;
      $framesName: "move-frames-" + $i;
      $moveDuration: 28000 + random(9000) + ms;

      animation-name: #{$framesName};
      animation-duration: $moveDuration;
      animation-delay: random(37000) + ms;

      @keyframes #{$framesName} {
        from {
          transform: translate3d(
            #{random(100) + vw},
            #{$startPositionY + vh},
            0
          );
        }

        to {
          transform: translate3d(
            #{random(100) + vw},
            #{- $startPositionY - random(30) + vh},
            0
          );
        }
      }

      .circle {
        animation-delay: random(4000) + ms;
      }
    }
  }
}
</style>
